Index: /trunk/src/VBox/HostDrivers/VBoxNetAdp/Makefile.kmk
===================================================================
--- /trunk/src/VBox/HostDrivers/VBoxNetAdp/Makefile.kmk	(revision 17024)
+++ /trunk/src/VBox/HostDrivers/VBoxNetAdp/Makefile.kmk	(revision 17025)
@@ -37,5 +37,5 @@
 VBoxNetAdp_DEFS             = IN_RT_R0 VBOX_SVN_REV=$(VBOX_SVN_REV) IN_SUP_STATIC
 VBoxNetAdp_LDFLAGS.darwin   = -v -Wl,-whyload -Wl,-v -Wl,-whatsloaded
-VBoxNetAdp_LDFLAGS.solaris += -N misc/gld
+VBoxNetAdp_LDFLAGS.solaris += -N misc/gld -N drv/vboxdrv
 VBoxNetAdp_INCS             = \
 	.
Index: /trunk/src/VBox/HostDrivers/VBoxNetAdp/VBoxNetAdp.c
===================================================================
--- /trunk/src/VBox/HostDrivers/VBoxNetAdp/VBoxNetAdp.c	(revision 17024)
+++ /trunk/src/VBox/HostDrivers/VBoxNetAdp/VBoxNetAdp.c	(revision 17025)
@@ -35,4 +35,5 @@
 #include <iprt/uuid.h>
 
+#ifndef RT_OS_SOLARIS
 #include <net/ethernet.h>
 #include <net/if_ether.h>
@@ -43,4 +44,5 @@
 #include <sys/errno.h>
 #include <sys/param.h>
+#endif
 
 
Index: /trunk/src/VBox/HostDrivers/VBoxNetAdp/solaris/VBoxNetAdp-solaris.c
===================================================================
--- /trunk/src/VBox/HostDrivers/VBoxNetAdp/solaris/VBoxNetAdp-solaris.c	(revision 17024)
+++ /trunk/src/VBox/HostDrivers/VBoxNetAdp/solaris/VBoxNetAdp-solaris.c	(revision 17025)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2008 Sun Microsystems, Inc.
+ * Copyright (C) 2009 Sun Microsystems, Inc.
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -52,4 +52,5 @@
 #include <sys/gld.h>
 
+#include "../VBoxNetAdpInternal.h"
 
 /*******************************************************************************
@@ -65,10 +66,4 @@
 static int VBoxNetAdpSolarisAttach(dev_info_t *pDip, ddi_attach_cmd_t enmCmd);
 static int VBoxNetAdpSolarisDetach(dev_info_t *pDip, ddi_detach_cmd_t enmCmd);
-
-static int VBoxNetAdpSolarisModOpen(queue_t *pQueue, dev_t *pDev, int fFile, int fStream, cred_t *pCred);
-static int VBoxNetAdpSolarisModClose(queue_t *pQueue, int fFile, cred_t *pCred);
-static int VBoxNetAdpSolarisModReadPut(queue_t *pQueue, mblk_t *pMsg);
-static int VBoxNetAdpSolarisModWritePut(queue_t *pQueue, mblk_t *pMsg);
-static int VBoxNetAdpSolarisModWriteService(queue_t *pQueue);
 
 /**
@@ -404,6 +399,6 @@
                     if (rc == DDI_SUCCESS)
                     {
+                        gld_mac_free(pMacInfo);
                         RTMemFree(pState);
-                        gld_mac_free(pMacInfo);
                         return DDI_SUCCESS;
                     }
@@ -464,5 +459,4 @@
 static int vboxNetAdpSolarisStub(gld_mac_info_t *pMacInfo)
 {
-    NOREF(pMacInfo);
     return GLD_SUCCESS;
 }
@@ -471,7 +465,4 @@
 static int vboxNetAdpSolarisSetMulticast(gld_mac_info_t *pMacInfo, unsigned char *pMulticastAddr, int fMulticast)
 {
-    NOREF(pMacInfo);
-    NOREF(pMulticastAddr);
-    NOREF(fMulticast);
     return GLD_SUCCESS;
 }
@@ -480,7 +471,26 @@
 static int vboxNetAdpSolarisSetPromisc(gld_mac_info_t *pMacInfo, int fPromisc)
 {
-    NOREF(pMacInfo);
-    NOREF(fPromisc);
+    /* Host requesting promiscuous intnet connection... */
     return GLD_SUCCESS;
 }
 
+
+int vboxNetAdpOsConnectIt(PVBOXNETADP pThis)
+{
+    /* Nothing to do here. */
+    return VINF_SUCCESS;
+}
+
+
+int vboxNetAdpOsCreate(PVBOXNETADP pThis, PCRTMAC pMACAddress)
+{
+    /* Nothing to do here. */
+    return VINF_SUCCESS;
+}
+
+
+void vboxNetAdpOsDestroy(PVBOXNETADP pThis)
+{
+    /* Nothing to do here. */
+}
+
Index: /trunk/src/VBox/HostDrivers/VBoxNetAdp/solaris/vboxnet.conf
===================================================================
--- /trunk/src/VBox/HostDrivers/VBoxNetAdp/solaris/vboxnet.conf	(revision 17024)
+++ /trunk/src/VBox/HostDrivers/VBoxNetAdp/solaris/vboxnet.conf	(revision 17025)
@@ -3,5 +3,5 @@
 # Solaris Host VBoxNet Configuration
 #
-# Copyright (C) 2008 Sun Microsystems, Inc.
+# Copyright (C) 2009 Sun Microsystems, Inc.
 #
 # This file is part of VirtualBox Open Source Edition (OSE), as