Index: trunk/src/VBox/Frontends/VirtualBox/include/VBoxImportApplianceWgt.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/include/VBoxImportApplianceWgt.h	(revision 17051)
+++ trunk/src/VBox/Frontends/VirtualBox/include/VBoxImportApplianceWgt.h	(revision 17053)
@@ -43,4 +43,9 @@
     bool isValid() const { return mAppliance != NULL; }
 
+    static int minGuestRAM() { return mMinGuestRAM; }
+    static int maxGuestRAM() { return mMaxGuestRAM; }
+    static int minGuestCPUCount() { return mMinGuestCPUCount; }
+    static int maxGuestCPUCount() { return mMaxGuestCPUCount; }
+
 public slots:
     void restoreDefaults();
@@ -50,7 +55,14 @@
 
 private:
+    static void initSystemSettings();
+
     /* Private member vars */
     CAppliance *mAppliance;
     VirtualSystemModel *mModel;
+
+    static int mMinGuestRAM;
+    static int mMaxGuestRAM;
+    static int mMinGuestCPUCount;
+    static int mMaxGuestCPUCount;
 };
 
Index: trunk/src/VBox/Frontends/VirtualBox/include/VBoxImportApplianceWzd.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/include/VBoxImportApplianceWzd.h	(revision 17051)
+++ trunk/src/VBox/Frontends/VirtualBox/include/VBoxImportApplianceWzd.h	(revision 17053)
@@ -30,24 +30,4 @@
 class QIWidgetValidator;
 
-class VBoxImportAppliance
-{
-public:
-    static void import (QWidget *aParent = NULL);
-
-    static int minGuestRAM() { return mMinGuestRAM; }
-    static int maxGuestRAM() { return mMaxGuestRAM; }
-    static int minGuestCPUCount() { return mMinGuestCPUCount; }
-    static int maxGuestCPUCount() { return mMaxGuestCPUCount; }
-
-private:
-    /* Private member vars */
-    static void initSystemSettings();
-
-    static int mMinGuestRAM;
-    static int mMaxGuestRAM;
-    static int mMinGuestCPUCount;
-    static int mMaxGuestCPUCount;
-};
-
 class VBoxImportApplianceWzd : public QIWithRetranslateUI<QIAbstractWizard>,
                                public Ui::VBoxImportApplianceWzd
@@ -71,4 +51,5 @@
 
 private:
+    /* Private member vars */
     QIWidgetValidator *mWValFileSelector;
 };
Index: trunk/src/VBox/Frontends/VirtualBox/src/VBoxImportApplianceWgt.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/VBoxImportApplianceWgt.cpp	(revision 17051)
+++ trunk/src/VBox/Frontends/VirtualBox/src/VBoxImportApplianceWgt.cpp	(revision 17053)
@@ -408,5 +408,5 @@
                 {
                     QSpinBox *e = new QSpinBox (aParent);
-                    e->setRange (VBoxImportAppliance::minGuestCPUCount(), VBoxImportAppliance::maxGuestCPUCount());
+                    e->setRange (VBoxImportApplianceWgt::minGuestCPUCount(), VBoxImportApplianceWgt::maxGuestCPUCount());
                     editor = e;
                     break;
@@ -415,5 +415,5 @@
                 {
                     QSpinBox *e = new QSpinBox (aParent);
-                    e->setRange (VBoxImportAppliance::minGuestRAM(), VBoxImportAppliance::maxGuestRAM());
+                    e->setRange (VBoxImportApplianceWgt::minGuestRAM(), VBoxImportApplianceWgt::maxGuestRAM());
                     e->setSuffix (" " + VBoxImportApplianceWgt::tr ("MB"));
                     editor = e;
@@ -961,4 +961,9 @@
 // VBoxImportApplianceWgt
 
+int VBoxImportApplianceWgt::mMinGuestRAM = -1;
+int VBoxImportApplianceWgt::mMaxGuestRAM = -1;
+int VBoxImportApplianceWgt::mMinGuestCPUCount = -1;
+int VBoxImportApplianceWgt::mMaxGuestCPUCount = -1;
+
 VBoxImportApplianceWgt::VBoxImportApplianceWgt (QWidget *aParent)
     : QIWithRetranslateUI<QWidget> (aParent)
@@ -966,4 +971,7 @@
     , mModel (NULL)
 {
+    /* Make sure all static content is properly initialized */
+    initSystemSettings();
+
     /* Apply UI decorations */
     Ui::VBoxImportApplianceWgt::setupUi (this);
@@ -1088,2 +1096,17 @@
 }
 
+/* static */
+void VBoxImportApplianceWgt::initSystemSettings()
+{
+    if (mMinGuestRAM == -1)
+    {
+        /* We need some global defaults from the current VirtualBox
+           installation */
+        CSystemProperties sp = vboxGlobal().virtualBox().GetSystemProperties();
+        mMinGuestRAM = sp.GetMinGuestRAM();
+        mMaxGuestRAM = sp.GetMaxGuestRAM();
+        mMinGuestCPUCount = sp.GetMinGuestCPUCount();
+        mMaxGuestCPUCount = sp.GetMaxGuestCPUCount();
+    }
+}
+
Index: trunk/src/VBox/Frontends/VirtualBox/src/VBoxImportApplianceWzd.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/VBoxImportApplianceWzd.cpp	(revision 17051)
+++ trunk/src/VBox/Frontends/VirtualBox/src/VBoxImportApplianceWzd.cpp	(revision 17053)
@@ -29,92 +29,4 @@
 
 ////////////////////////////////////////////////////////////////////////////////
-// VBoxImportAppliance
-
-int VBoxImportAppliance::mMinGuestRAM = -1;
-int VBoxImportAppliance::mMaxGuestRAM = -1;
-int VBoxImportAppliance::mMinGuestCPUCount = -1;
-int VBoxImportAppliance::mMaxGuestCPUCount = -1;
-
-/* static */
-void VBoxImportAppliance::import (QWidget *aParent /* = NULL */)
-{
-    initSystemSettings();
-
-    VBoxImportApplianceWzd importWzd (aParent);
-    if (importWzd.exec() == QDialog::Accepted)
-    {
-    }
-    return;
-
-#if 0
-    /* We need a file to import; request one from the user */
-    QString file = VBoxGlobal::getOpenFileName ("",
-                                                VBoxGlobal::tr ("Open Virtualization Format (%1)").arg ("*.ovf"),
-                                                aParent,
-                                                VBoxGlobal::tr ("Select an appliance to import"));
-//    QString file = "/home/poetzsch/projects/innotek/plan9.ovf";
-//    QString file = "/Users/poetzsch/projects/innotek/plan9.ovf";
-    if (!file.isEmpty())
-    {
-        CVirtualBox vbox = vboxGlobal().virtualBox();
-        /* Create a appliance object */
-        CAppliance appliance = vbox.CreateAppliance();
-        bool fResult = appliance.isOk();
-        if (fResult)
-        {
-            /* Read the appliance */
-            appliance.Read (file);
-            fResult = appliance.isOk();
-            if (fResult)
-            {
-                /* Now we have to interpret that stuff */
-                appliance.Interpret();
-                fResult = appliance.isOk();
-                if (fResult)
-                {
-                    /* Let the user do some tuning */
-                    VBoxImportApplianceWgt settingsDlg (&appliance, aParent);
-                    if (settingsDlg.exec() == QDialog::Accepted)
-                    {
-                        /* Start the import asynchronously */
-                        CProgress progress;
-                        progress = appliance.ImportMachines();
-                        fResult = appliance.isOk();
-                        if (fResult)
-                        {
-                            /* Show some progress, so the user know whats going on */
-                            vboxProblem().showModalProgressDialog (progress, VBoxImportApplianceWgt::tr ("Importing Appliance ..."), aParent);
-                            if (!progress.isOk() || progress.GetResultCode() != 0)
-                            {
-                                vboxProblem().cannotImportAppliance (progress, appliance);
-                                return;
-                            }
-                        }
-                    }
-                }
-            }
-        }
-        if (!fResult)
-            vboxProblem().cannotImportAppliance (appliance);
-    }
-#endif
-}
-
-/* static */
-void VBoxImportAppliance::initSystemSettings()
-{
-    if (mMinGuestRAM == -1)
-    {
-        /* We need some global defaults from the current VirtualBox
-           installation */
-        CSystemProperties sp = vboxGlobal().virtualBox().GetSystemProperties();
-        mMinGuestRAM = sp.GetMinGuestRAM();
-        mMaxGuestRAM = sp.GetMaxGuestRAM();
-        mMinGuestCPUCount = sp.GetMinGuestCPUCount();
-        mMaxGuestCPUCount = sp.GetMaxGuestCPUCount();
-    }
-}
-
-////////////////////////////////////////////////////////////////////////////////
 // VBoxImportApplianceWzd
 
@@ -133,5 +45,4 @@
     mFileSelector->setFileDialogTitle (tr ("Select an appliance to import"));
     mFileSelector->setFileFilters (tr ("Open Virtualization Format (%1)").arg ("*.ovf"));
-//    mFileSelector->setPath ("/home/poetzsch/downloads/Appliances/Plan9.ovf");
 #ifdef Q_WS_MAC
     /* Editable boxes are uncommon on the Mac */
Index: trunk/src/VBox/Frontends/VirtualBox/src/VBoxSelectorWnd.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/VBoxSelectorWnd.cpp	(revision 17051)
+++ trunk/src/VBox/Frontends/VirtualBox/src/VBoxSelectorWnd.cpp	(revision 17053)
@@ -746,5 +746,7 @@
 void VBoxSelectorWnd::fileImportAppliance()
 {
-    VBoxImportAppliance::import (this);
+    VBoxImportApplianceWzd wzd (this);
+
+    wzd.exec();
 }
 